; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         site-start.el
; RCS:          $Header: $
; Description:  Runtime fixups for OEmacs.
;		The code in this file is executed *BEFORE* the user's .emacs
;		file is processed.
; Author:       Darryl Okahata
; Created:      Wed Jul  7 23:51:13 1993
; Modified:     Mon Jul 12 19:49:30 1993 (darrylo@home) darrylo@hostigos
; Language:     Emacs-Lisp
; Package:      N/A
; Status:       Experimental
;
; (C) Copyright 1993, Darryl Okahata, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq Info-default-directory-list
      (let (file dirs)
	(setq file (substitute-in-file-name "$EMACSTOPDIR/elisp"))
	(if (file-directory-p file)
	    (setq dirs (cons file dirs)))
	(setq dirs (cons (expand-file-name (file-name-as-directory
					    configure-info-directory))
			 dirs))
	dirs))

;; insure that TERM is set
(or (getenv "TERM")
    (setenv "TERM" "ibmpc"))

;; Set $HOME to $EMACSTOPDIR if $HOME is not set
(let (d)
  (or (getenv "HOME")
      (and (setq d (expand-file-name (getenv "EMACSTOPDIR")))
	   (setenv "HOME" d))))
