/* s- file for MSDOS with DJGPP (created for version 1.09)

   Chris Boucher, ccb@soton.ac.uk
   Updated by Darryl Okahata, darrylo@sr.hp.com

   This file describes the parameters that s- files should define or not.
   Copyright (C) 1985, 1986 Free Software Foundation, Inc.

This file is part of GNU Emacs.

GNU Emacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GNU Emacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


/*
 *	Define symbols to identify the version of Unix this is.
 *	Define all the symbols that apply correctly.
 */

/* #define UNIPLUS */
/* #define USG5 */
/* #define USG */
/* #define HPUX */
/* #define UMAX */
/* #define BSD4_1 */
/* #define BSD4_2 */
/* #define BSD4_3 */
/* #define BSD */
/* #define VMS */
#define IBMPC
#ifndef MSDOS
# define MSDOS
#endif

#define USE_LOCAL_DIR_H

/* Define CTRL_BREAK_INTERRUPTS to make Ctrl-Break interrupt Emacs.
   Note that defining this makes Emacs run slower.
   This also requires the use of a special GO32 extender.  */

#define CTRL_BREAK_INTERRUPTS

#define SYSTEM_MALLOC
#undef GNU_MALLOC
#undef REL_ALLOC

/*
 * Define BROKEN_STAT if stat() and friends relies upon the TZ environment
 * variable.
 */
#define BROKEN_STAT

/*
 * Define DIE_UPON_STARTUP_ERROR if you want Emacs to immediately terminate if
 * CANNOT DUMP is defined and an error occurs during loadup.  This prevents a
 * seemingly unquittable Emacs if Emacs is improperly configured and loadup.el
 * cannot be found.
 */
#define DIE_UPON_STARTUP_ERROR

/*
 * Define ENABLE_SHRUNK_BUFFER_AUTOSAVE if you want to enable autosaving of
 * buffers which have shrunk a lot.
 */
#define ENABLE_SHRUNK_BUFFER_AUTOSAVE

#define PC_DIRECT_SCREEN
#define PC_MOUSE
#ifdef PC_DIRECT_SCREEN
# define PC_FACES
#endif

/* DESQview/X support... */
#ifdef DVX
#define HAVE_X_WINDOWS
#define HAVE_X11
#define HAVE_X_MENU
#define MULTI_FRAME
#define HAVE_SOCKETS
#define HAVE_SELECT
/*#undef CTRL_BREAK_INTERRUPTS*/
#undef PC_DIRECT_SCREEN
#undef PC_MOUSE
#undef PC_FACES
#define PURESIZE	220000
#else
#define PURESIZE	200000
#endif

/* SYSTEM_TYPE should indicate the kind of system you are using.
 It sets the Lisp variable system-type.  */

#define SYSTEM_TYPE "ms-dos"

/* NOMULTIPLEJOBS should be defined if your system's shell
 does not have "job control" (the ability to stop a program,
 run some other program, then continue the first one).  */

#define NOMULTIPLEJOBS

/* Emacs can read input using SIGIO and buffering characters itself,
   or using CBREAK mode and making C-g cause SIGINT.
   The choice is controlled by the variable interrupt_input.
   Define INTERRUPT_INPUT to make interrupt_input = 1 the default (use SIGIO)

   SIGIO can be used only on systems that implement it (4.2 and 4.3).
   CBREAK mode has two disadvatages
     1) At least in 4.2, it is impossible to handle the Meta key properly.
        I hear that in system V this problem does not exist.
     2) Control-G causes output to be discarded.
        I do not know whether this can be fixed in system V.

   Another method of doing input is planned but not implemented.
   It would have Emacs fork off a separate process
   to read the input and send it to the true Emacs process
   through a pipe.
*/

/* #define INTERRUPT_INPUT */

/* Letter to use in finding device name of first pty,
  if system supports pty's.  'a' means it is /dev/ptya0  */

/* #define FIRST_PTY_LETTER 'a' */

/*
 *	Define HAVE_TIMEVAL if the system supports the BSD style clock values.
 *	Look in <sys/time.h> for a timeval structure.
 */

#define HAVE_TIMEVAL

/*
 *	Define HAVE_SELECT if the system supports the `select' system call.
 */

/* #define HAVE_SELECT */

/*
 *	Define HAVE_PTYS if the system supports pty devices.
 */

/* #define HAVE_PTYS */

/*
 *	Define NONSYSTEM_DIR_LIBRARY to make Emacs emulate
 *      The 4.2 opendir, etc., library functions.
 */

/* #define NONSYSTEM_DIR_LIBRARY */

/* Define this symbol if your system has the functions bcopy, etc. */

#define BSTRING

/* subprocesses should be defined if you want to
   have code for asynchronous subprocesses
   (as used in M-x compile and M-x shell).
   This is generally OS dependent, and not supported
   under most USG systems. */

/* #define subprocesses */

/* If your system uses COFF (Common Object File Format) then define the
   preprocessor symbol "COFF". */

/* #define COFF */

/* define MAIL_USE_FLOCK if the mailer uses flock
   to interlock access to /usr/spool/mail/$USER.
   The alternative is that a lock file named
   /usr/spool/mail/$USER.lock.  */

/* #define MAIL_USE_FLOCK */

/* Define CLASH_DETECTION if you want lock files to be written
   so that Emacs can tell instantly when you try to modify
   a file that someone else has modified in his Emacs.  */

/* #define CLASH_DETECTION */

/* Here, on a separate page, add any special hacks needed
   to make Emacs work on this system.  For example,
   you might define certain system call names that don't
   exist on your system, or that do different things on
   your system and must be used only through an encapsulation
   (Which you should place, by convention, in sysdep.c).  */

/* Some compilers tend to put everything declared static
   into the initialized data area, which becomes pure after dumping Emacs.
   On these systems, you must #define static as nothing to foil this.
   Note that emacs carefully avoids static vars inside functions.  */

/* #define static */

/* Special hacks needed to make Emacs run on this system.  */

/*
 *	Make the sigsetmask function go away.  Don't know what the
 *	ramifications of this are, but doesn't seem possible to
 *	emulate it properly anyway at this point.
 */

/* #define sigsetmask(mask)	/* Null expansion */

/* On USG systems these have different names */

#define index strchr
#define rindex strrchr

/* Use terminfo instead of termcap.  */

/* #define TERMINFO */

/* The rename system call exists.  */

#define HAVE_RENAME

#ifdef PC_FACES
# define SYMS_SYSTEM syms_of_dosfns(); syms_of_pc_term(); syms_of_pc_faces()
#else
# define SYMS_SYSTEM syms_of_dosfns(); syms_of_pc_term();
#endif

#define _setjmp setjmp
#define _longjmp longjmp

#define HAVE_GETPAGESIZE

/* New access () routine. */
#ifdef access
#undef access
#endif
#define access sys_access

/* New getwd () routine. */
#ifdef getwd
#undef getwd
#endif
#define getwd sys_getwd

/* New chdir () routine. */
#ifdef chdir
#undef chdir
#endif
#define chdir sys_chdir

#define exception	libm_exception

#ifndef MAXPATHLEN
# define MAXPATHLEN	256
# define _PARAM_H_ /* avoid sys/param.h */
#endif

#ifndef MAXNAMLEN
# define MAXNAMLEN	256
#endif

#define NULL_DEVICE	"nul"
#define EXEC_SUFFIXES	".exe:.com:.bat:"
#define SEPCHAR		';'

#define NO_MODE_T

#define LOCALTIME_CACHE
